extern "C" {
	
#include "prizm.h"
#include "CBP.h"

#include "CBP_sys.h"

//---------------------------------------------------------------------------------------------

void Fkey_Icon(int n, int IconNo){
	unsigned int* iresult;	
	if ( ( ( IconNo>1248+6 ) && (OS_Version()<=104) ) ||
		 ( ( IconNo>1276+6 ) && (OS_Version()<=300) ) ||
		 ( ( IconNo>1378+6 ) && (OS_Version()<=310) ) ||
		 ( ( IconNo>1379+6 ) && (OS_Version()<=311) ) ||
		 ( ( IconNo>1394+6 ) && (OS_Version()<=320) ) ||
		 ( ( IconNo>1400+6 ) && (OS_Version()<=330) ) || ( IconNo>1500 ) ) {
		 IconNo=0;
	}
	if ( ( IconNo==1325 ) && (OS_Version()<=300) )  { Fkey_dispN( n, "Extd"); return ; }
	GetFKeyPtr( IconNo, &iresult);	//  
	FKey_Display(n, iresult);
}

//---------------------------------------------------------------------------------------------
int GetFkeyColor(int n){
	unsigned short *VRAM=(unsigned short *)PictAry[0];
	return VRAM[ n*64+3 +193*384 ];
}
int GetFkeyBackColor(int n){
	unsigned short *VRAM=(unsigned short *)PictAry[0];
	return VRAM[ n*64+3 +212*384 ];
}

void Fkey_Line2( int n ){
	unsigned short *VRAM=(unsigned short *)PictAry[0];
	unsigned short c=GetFkeyColor(n);
	int x,y;
	for(x=n*64+4;x<n*64+60;x++){
		VRAM[x+213*384]=c;
		VRAM[x+214*384]=c;
	}
	for(y=196;y<=215;y++){
		for(x=n*64+63;x<n*64+65;x++){
			VRAM[x+y*384]=0xFFFF;	// white
		}
	}
}
void Fkey_Line3( int n ){
	unsigned short *VRAM=(unsigned short *)PictAry[0];
	unsigned short c=GetFkeyColor(n);
	int x,y;
	for(x=n*64+4;x<n*64+55;x++){
		VRAM[x+213*384]=c;
		VRAM[x+214*384]=c;
	}
	for(y=208;y<=214;y++){
		for(x=n*64+63-y+208;x<n*64+63;x++){
			VRAM[x+y*384]=0xFFFF;	// white
		}
	}
	for(y=196;y<=215;y++){
		for(x=n*64+63;x<n*64+65;x++){
			VRAM[x+y*384]=0xFFFF;	// white
		}
	}
}
void Fkey_ClearBox( int n ){
	unsigned short *VRAM=(unsigned short *)PictAry[0];
	unsigned short c=GetFkeyBackColor(n);
	int x,y;
	for(y=195;y<212;y++){
		for(x=n*64+20;x<n*64+40;x++){
			VRAM[x+y*384]=c;
		}
	}
}

void Fkey_Clear(int n) {
		unsigned int* iresult;	
		GetFKeyPtr(0x0, &iresult);	// 
		FKey_Display(n, iresult);
}

void Fkey_dispN(int n,char *buf) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0476, &iresult);	//  .  		,white
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+3, 7*24+4, buf, GetFkeyColor(n), COLOR_WHITE, 0 );
		Fkey_Line2( n );
}
void Fkey_dispN2(int n,char *buf) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0476, &iresult);	//  .  		,white
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+3, 7*24+4, buf, GetFkeyColor(n), COLOR_WHITE, 0);
		Fkey_Line2( n );
}

void Fkey_dspRR(int n,char *buf) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0190, &iresult);	//  t		,black
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+1, 7*24+4, buf, COLOR_WHITE, GetFkeyColor(n), 0 );
		Fkey_Line2( n );
}
void Fkey_dispR(int n,char *buf) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0334, &iresult);	//  t		,black/
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+1, 7*24+4, buf, COLOR_WHITE, GetFkeyColor(n), 0 );
		Fkey_Line3( n );
}
void Fkey_DISPN(int n,char *buf) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0476, &iresult);	//  .  		,white
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+3, 7*24+4, buf, GetFkeyColor(n), COLOR_WHITE, 0);
		Fkey_Line2( n );
}

void Fkey_DISPR(int n,char *buf) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0190, &iresult);	//  t		,black
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+1, 7*24+4, buf, COLOR_WHITE, GetFkeyColor(n), 0 );
		Fkey_Line2( n );
}

void Fkey_dispN_ext(int n,char *buf, int ofset ) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0476, &iresult);	//  .  		,white
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+3, 7*24+4-ofset, buf, GetFkeyColor(n), COLOR_WHITE, 1 );	// ext char
		Fkey_Line2( n );
}
void Fkey_dispR_ext(int n,char *buf, int ofset ) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0334, &iresult);	//  t		,black/
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+1, 7*24+4-ofset, buf, COLOR_WHITE, GetFkeyColor(n), 1 );	// ext char
		Fkey_Line3( n );
}
void Fkey_dispNInit(int n) {
		unsigned int* iresult;
		GetFKeyPtr(0x005f, &iresult);	//INITIAL 	,white
		FKey_Display(3, iresult);
}		


void FkeyClear(int n) {
	Fkey_Icon(n, 0 );	// clear
}
void FkeyClearAll(){
	int n;
	for (n=0; n<6; n++ ) FkeyClear( n );
}

void Fkey_dspRB(int n,char *buffer) {
	Fkey_DISPR( n, buffer); 
}

void Fkey_AreaReverseVRAM( int n, int x1, int x2 ){
	unsigned short *VRAM=(unsigned short *)PictAry[0];
	unsigned short c =GetFkeyColor(n);
	unsigned short bc=GetFkeyBackColor(n);
	int x,y,d;
	for(y=192+3; y<=192+20; y++){
		for(x=n*64+x1; x<=n*64+x2; x++){
			d=VRAM[x+y*384];
			if ( d==c ) VRAM[x+y*384]=bc;
			if ( d==bc) VRAM[x+y*384]=c;
		}
	}
}
void Fkey_dispN_Aa(int n, char *buffer) {
	Fkey_dispN2(n,buffer);
//	Bdisp_AreaReverseVRAMx3( n*21+3, (7+0)*8+1, n*21+7, (7+0)*8+6);	// reverse
//	Bdisp_AreaReverseVRAM( n*64+3, 192+3, n*64+20, 192+20 );	// reverse
	Fkey_AreaReverseVRAM( n, 3, 19 );
}
void Fkey_dispN_aA(int n, char *buffer) {
	Fkey_dispN2(n,buffer);
//	Bdisp_AreaReverseVRAMx3( n*21+16, (7+0)*8+1, n*21+20, (7+0)*8+6);	// reverse
//	Bdisp_AreaReverseVRAM( n*64+46, 192+3, n*64+60, 192+20 );	// reverse
	Fkey_AreaReverseVRAM( n, 45, 60 );
}

}
